*
* initialize music system
*

initmusic:
	LDA	#<ROMADRS	; sound data address set
	STA	ADDRESS
	LDA	#>ROMADRS
	STA	ADDRESS+1
	LDA	#ROMADRS>>16			;assume BANK 0 for ROMADRS
	STA	ADDRESS+2
	jmp	mybootapu
initsound:
	lda	#$f8
	sta APU_port0
	LDA	#<ROMADRS2	; sound data address set
	STA	ADDRESS
	LDA	#>ROMADRS2
	STA	ADDRESS+1
	LDA	#ROMADRS2>>16			;assume BANK 0 for ROMADRS
	STA	ADDRESS+2
mybootapu:	
	JSR	BOOT_APU	; boot APU [sound program transfer ]

	lda	#0
	sta	frame
	sta	inputcount
	sta	outputcount

	LDA	#$00		; port clear
	STA	APU_PORT0	; sound clear

	rts
	
	
;**************************************
;*      SOUND BOOT LOADER  V1.1       *
;**************************************

BOOT_APU
	lda	#$f8
	sta  APU_port0

	PHP
	REP	#%00110000
	LDY	#0
	LDA	#$BBAA
BOOT_INITIAL
	CMP	APU_PORT0	;M16
	BNE	BOOT_INITIAL
	SEP	#%00100000;

	LDA 	#$CC
	BRA	BOOT_ENTRY1

BOOT_REPEAT
	LDA	[ADDRESS],Y
	INY
	BPL	BANKIT1
	LDY	#0
	INC	ADDRESS+2
BANKIT1

	XBA
	LDA	#0
	BRA	BOOT_ENTRY2

BOOT_LOOP
	XBA
	LDA	[ADDRESS],Y
	INY
	BPL	BANKIT2
	LDY	#0
	INC	ADDRESS+2
BANKIT2
	XBA
BOOT_WAIT1
	CMP	APU_PORT0
	BNE	BOOT_WAIT1
	INC	A
BOOT_ENTRY2
	REP	#%00100000
	STA	APU_PORT0	;M16
	SEP	#%00100000
	
	DEX
	BNE	BOOT_LOOP

BOOT_WAIT2
	CMP	APU_PORT0
	BNE	BOOT_WAIT2
BOOT_ZERO
	ADC	#3
	BEQ	BOOT_ZERO
BOOT_ENTRY1
	PHA			;>
	REP	#%00100000
	LDA	[ADDRESS],Y	;M16
	INY
	INY
	TAX
	LDA	[ADDRESS],Y	;M16
	INY
	INY
	STA	APU_PORT2	;M16
	SEP	#%00100000
	CPX	#1
	LDA	#0
	ROL	A

	STA	APU_PORT1
	ADC	#$7F
	PLA			;<
	STA	APU_PORT0
BOOT_WAIT3
	CMP	APU_PORT0
	BNE	BOOT_WAIT3
	BVS	BOOT_REPEAT
	PLP
	
	SET8		;return in 8 bit mode
	RTS
	
*
* sfx call
*

SoundEffects2	

;SoundEffects2 called with A in 8 bit mode . A  from sound buffer

	php
	sep	#$20
	sta  APU_port0
	inc	ADDRESS
	lda	ADDRESS
	sta	APU_port1
	plp
	SET8
	rtl
	
*
* sfx call by game code
*

;SoundEffects called with A in 8 bit mode . A = effect number....

soundeffects
	phy
	phx
	php
	sep	#$30
	tay
	lda	inputcount
	inc	a
	inc	a	
	sta	inputcount
	and	#$0f
	tax
	tya
	sta	soundbuffer,x			;silence for now
	plp
	plx
	ply
	SET8
	rtl

*
* vbl refresh routine
*

refreshsoundeffect
	php
	sep	#$30
	lda	frame
	and	#1
	bne	@1
	lda	outputcount
	cmp	inputcount
	beq	@1
	inc	a	
	inc	a
	sta	outputcount
	and	#$0f
	tax
	lda	soundbuffer,x
	jsl	soundeffects2
@1
	plp
	SET8
	rtl
	

